#include "StdAfx.h"
#include "listbox.h"
#include "CallMsgDlg2.h"

extern CSimpleArray<SavedNaviRecord_t> g_listJobSaved;
#define   m_btStd m_Btns
#define   m_btCommand (m_Btns+3)
void overhand_next_pos(SavedNaviRecord_t* pst,BOOL bWave2=1,int lastReachedPos = -1);

extern int gCurServiceId;
int gCurServiceIdSave = -1;
extern int gCurServiceBenach;
float get_dist (float Lat1_f64, float Lon1_f64, float Lat2_f64, float Lon2_f64 ) ;
static BUTTON_ITEMEX Button_Select[]= {	
	{ 130, 160,	201, 75,	IDS_POP2_CMD1    ,IDB_BTN_551x97, IDB_BTN_551x97_DN,0,0,550, 97,TitleFontWide,TitleFontHeight,FW_BOLD ,IDS_POP2_CMD1},
	{ 130, 260,	218, 74,	IDS_POP2_CMD2  ,IDB_BTN_551x97,IDB_BTN_551x97_DN,0,0,550,97,TitleFontWide,TitleFontHeight,FW_BOLD,IDS_POP2_CMD2},
	{ 130, 360,	218, 74,	IDS_Positionsliste  ,IDB_BTN_551x97,IDB_BTN_551x97_DN,0,0,550,97,TitleFontWide,TitleFontHeight,FW_BOLD,IDS_Positionsliste},
	{ 0, 0,	0, 0,0    ,0     ,0}
};


LRESULT CCallMsgDlg2::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	VButtonWnd::OnInitDialog(uMsg,  wParam,  lParam,  bHandled);
	//SetWindowPos(HWND_TOPMOST,0,0,SCREEN_W,SCREEN_H,SWP_NOSIZE);
	int i=0;
	gCurServiceIdSave = gCurServiceId;
	PlaySoundFile(_T("\\FlashDisk\\voice\\germany\\tour-sequence2.wav"),FALSE);
	BUTTON_ITEMEX * pBmpBut= Button_Select;
	while(pBmpBut && pBmpBut->uId!=0){
		CString str;
		if(pBmpBut->btTxtId) str.LoadString(pBmpBut->btTxtId);
		else str.LoadString(pBmpBut->uId); 
		CREATE_BTN_TRANS( m_btCommand[i],m_nIDBACK,str,(*pBmpBut));
		//if(pBmpBut->uId==ID_START || pBmpBut->uId==ID_START) m_btCommand[i].SetTextColor( RGB(0xFF,0xFF,0xFF));
		m_btCommand[i].EnableWindow();
		pBmpBut++;
		i++;
	}
	SetTimer(5,1000);
	if(ghEventPopup==NULL) ghEventPopup = CreateEvent(NULL,TRUE,FALSE,L"POPUP:SHOW");   
	SetEvent(ghEventPopup); 
    return 0;  
} 

LRESULT CCallMsgDlg2::OnTimer (UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
{
	if(m_nTimerCount==0 || (gCurServiceId!=-1 &&  gCurServiceIdSave != -1  && gCurServiceId!= gCurServiceIdSave))
	{
		PlaySoundFile(_T("\\FlashDisk\\voice\\germany\\tour-sequence3.wav"),FALSE);		
		SavedNaviRecord_t& st = g_listJobSaved[m_nJob];
		if(st.lastReachedPos==-1)
			st.lastReachedPos = GetLastReachedPos(st);
		overhand_next_pos(&st,1,st.lastReachedPos);
		DestroyWindow();
	}else
	{
		m_nTimerCount--;
		
	}
	return 0;
}


void CCallMsgDlg2::OnPaintExt(HDC hDC,CRect&rcPaint)
{

	DrawDC Draw(hDC);

	Draw.SetDrawBkMode(TRANSPARENT);
	Draw.SetDrawTextColor(RGB(0,0,0));
	Draw.SetMsgBoxFont() ;
	CRect rc(130,30,760,420);

	CString str;
	str.LoadString(IDS_EXTRA_POP2_MSG ); 
	Draw.DrawGPSOverIPStringRect((LPTSTR)(LPCTSTR)str,rc,DT_EXPANDTABS);
	


}

LRESULT CCallMsgDlg2::OnCmd1(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	SavedNaviRecord_t& st = g_listJobSaved[m_nJob];
	if(st.lastReachedPos==-1)
		st.lastReachedPos = GetLastReachedPos(st);
	overhand_next_pos(&st,1,st.lastReachedPos);
	ShowWindow(SW_HIDE);
   	DestroyWindow();
	return 0;
}


LRESULT CCallMsgDlg2::OnCmd2(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	SavedNaviRecord_t& st = g_listJobSaved[m_nJob];
	overhand_next_pos(&st,1);
	//ShowWindow(SW_HIDE);
   	DestroyWindow();
	return 0;
}
#include "VNewWnd.h"
LRESULT CCallMsgDlg2::OnPosList(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	SavedNaviRecord_t& st = g_listJobSaved[m_nJob];
	VNewWnd wDlg(IDBI_BK_LISTE,IDB_ICON_TOUR2,1);
	wDlg.m_pState = m_pState ;
	wsprintf(wDlg.m_szPath,L"%s",st.strJob);
	wDlg.m_nSel = st.nCurrentReached;
	int nRet =wDlg.DoModal();
	int nSel = wDlg.m_nSel;
   	DestroyWindow();
	return 0;
}

extern CCallMsgDlg2 *  g_pWndPop2 ; ;
CCallMsgDlg2* showExtraPop2(int iJob,int iPos)
{
	//CCallMsgDlg2* pWndPopup = NULL;	
///	CString str;//(L"Die Markerliste wird nun von der Zentrale\nabgerufen und aktualisiert!");
//	UINT id = IDS_EXTRA_POP2_MSG;
	if(g_pWndPop2 && g_pWndPop2->IsWindow()) 
	{
		g_pWndPop2->ShowWindow(SW_SHOW);
		g_pWndPop2->BringWindowToTop();
		SetForegroundWindow(g_pWndPop2->m_hWnd);
		return g_pWndPop2 ;
	}else if(g_pWndPop2) delete g_pWndPop2;
			
//	str.LoadString(id);
	//if(m_pWndPopup) delete m_pWndPopup;
	g_pWndPop2 =  new CCallMsgDlg2(IDB_BK,NULL,IDB_ICON_TOUR2); // (0,NULL,IDB_PHONE_ICON); //(IDB_BK_POP_NEW,NULL,IDB_PHONE_ICON);
	g_pWndPop2->m_nJob = iJob;
	g_pWndPop2->m_nPos= iPos;
	g_pWndPop2->Create(NULL);
	g_pWndPop2->ShowWindow(SW_SHOW);
	g_pWndPop2->BringWindowToTop();
	SetForegroundWindow(g_pWndPop2->m_hWnd);
	return g_pWndPop2;
}


