#include "StdAfx.h"
#include "publicctrl.h"
#include "DrawLib.h"
#include "IncommingPop.h"
#include "shellapi.h"

#ifndef IDB_BK_POP_DETAIL
#define IDB_BK_POP_DETAIL -1
#endif


extern BOOL g_bGiveup;
#define   m_btStd m_Btns
#define   m_btCommand (m_Btns+3)

#define SOUND_POPUP_PATH  __FLASHDISK_W_ L"\\popup.wav"

void fire_wakeup_event();

extern DWORD g_dwPopTimeout;
extern TCHAR* g_pszFileDelay;
extern BOOL g_bPopDelay,g_bAutoClose;
HANDLE ghEventPopup = NULL;
BOOL g_bPopup = FALSE;
LRESULT CIncommingPop::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
g_bPopup = TRUE;
	VButtonWnd::OnInitDialog(uMsg,  wParam,  lParam,  bHandled);
	SetWindowPos(HWND_TOPMOST,0,0,SCREEN_W,SCREEN_H,SWP_NOSIZE);
	int i=0;
	BUTTON_ITEM * pBmpBut= m_BmpButtonTmpl;
	while(pBmpBut && pBmpBut->uId!=0){
	   CREATE_BTN_TRANS2( m_btStd[i],m_nIDBACK,(*pBmpBut));
	   pBmpBut++;
	   i++;

	}
	i=0;
	if(m_TxtButtonTmpl){
		BUTTON_ITEMEX * pBmpBut= m_TxtButtonTmpl;
		while(pBmpBut && pBmpBut->uId!=0){
			CString str;
			if(pBmpBut->btTxtId) str.LoadString(pBmpBut->btTxtId);
			else str.LoadString(pBmpBut->uId); 
			CREATE_BTN_TRANS( m_btCommand[i],m_nIDBACK,str,(*pBmpBut));
			//if(pBmpBut->uId==ID_START || pBmpBut->uId==ID_START) m_btCommand[i].SetTextColor( RGB(0xFF,0xFF,0xFF));
			m_btCommand[i].EnableWindow();
			pBmpBut++;
			i++;
		}
	}

	//if(m_nIDBACK==IDB_BK_POP_DETAIL)
	SetTimer(5,5000);

	if(m_toAlive>0) SetTimer(6,m_toAlive);
#ifdef UNDER_CE
 
	if(  m_nSoundCount>0||m_bSound)
	{	
		PlayCPSSSound();
		fire_wakeup_event();
	}
#endif
	m_nTimerCount = 0;
	if(m_nAutoEndTimer>0) SetTimer(6,m_nAutoEndTimer);

	if(ghEventPopup==NULL) ghEventPopup = CreateEvent(NULL,TRUE,FALSE,L"POPUP:SHOW");   
	SetEvent(ghEventPopup); 
    return 0;  
} 
LRESULT CIncommingPop::OnTimer (UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
{
	if( (wParam)==0x6 && m_toAlive>0)
	{
		g_bPopup = FALSE;
		KillTimer(6);
		ShowWindow(SW_HIDE);
   		EndDialog(1);
	}else{
		m_nTimerCount++;
		if(g_bPopDelay)
		{
			g_bPopup = FALSE;
			ShowWindow(SW_HIDE);
	  		EndDialog(0x10);
		}else
		{
			  BOOL bOK = SetForegroundWindow(m_hWnd);
		     
		}
		if( (g_bAutoClose && ( m_nIDBACK != IDB_BK ) ) )
		{
			 
			if(m_nTimerCount>=6||(g_dwPopTimeout==30 && m_nTimerCount>=2)) 
			{
				PlayCPSSSound();
				
			}
			if((DWORD)m_nTimerCount*5>=g_dwPopTimeout)
			{
				g_bPopup = FALSE;
				ShowWindow(SW_HIDE);
  				EndDialog(0x11);
			}
			
		}else if( m_nSoundCount>0)
		{
			 if((m_nTimerCount%6)==0)
			 {
				m_nSoundCount--;
				PlayCPSSSound();
			}
		}
	}
	return 0;
}

 
void CIncommingPop::OnPaintExt(HDC hDC,CRect&rcPaint)
{
	DrawDC Draw(hDC);

	Draw.SetDrawBkMode(TRANSPARENT);
	Draw.SetDrawTextColor(RGB(0,0,0));
	Draw.SetDrawFontSize(40,17,FW_NORMAL,__FONT_NORMAL__);
	CRect rc(80,110,710,420);
	if(m_DrawList && m_DrawList->hasTwoIcon())
	{
		rc.top = 160;
	}
	Draw.DrawGPSOverIPStringRect(m_sTitle,rc,DT_CENTER|DT_EXPANDTABS);
	if(m_sExtra &&m_nIDBACK==IDB_BK_POP_DETAIL)// only for job application
	{
		Draw.SetDrawFontSize(18,8,FW_NORMAL,__FONT_NORMAL__);
		////
		Draw.DrawGPSOverIPStringRect(m_sExtra,CRect(EXTRA_TEXT_POS),DT_CENTER);
	}
	
}
LRESULT CIncommingPop::OnOK(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
g_bPopup = FALSE;
//	ShowWindow(SW_HIDE);
PostMessage(g_hListenWnd,WM_USER_INDICATE,9,9);

			while(FindWindow(NULL,"InOneJobDetail")!=NULL)
			{
				MessageLoop(g_hListenWnd);
				
			}
   	EndDialog(FALSE);
	return 0;
}


LRESULT CIncommingPop::OnCancelMsg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
g_bPopup = FALSE;
	ShowWindow(SW_HIDE);
	BOOL bZiel = 0;
	int nP=m_jobFilePath.Find(L".job");
	if(nP!=-1) bZiel = 1;
	if(bZiel) 
	{
		TCHAR *szJob = (LPTSTR)(LPCTSTR)jobFilePath;
		TCHAR* sz = wcsrchr(szJob,TCHAR('\\'));
		if(sz) szJob= sz+1;
		DeleteJob(szJob);
	}
   	EndDialog(FALSE);
	return 0;
}



