#pragma once
#define __MSG_SEP_LINE__  TEXT("\r\n=============================\r\n")
#include "CPSS_Dialog.h"
#include "listbox.h"

#define WM_INITUPDATE WM_USER+10

inline TCHAR * FormatMsg(LPCTSTR pMsg)
{
#define __MARKER__ L"================================="	
#define __SEP__ 0x000A
#define __SEP0__ 0x000D

TCHAR* m_pMsg = new TCHAR[wcslen(pMsg)+8];
	const TCHAR *p;
	p  = wcsstr(pMsg,__MARKER__);
	if(p)
	{
		TCHAR* pDest= m_pMsg;
		int c = p-pMsg;
		wcsncpy(pDest,pMsg ,c);
		pDest+=c;
		if( *(p-1)!=__SEP__)
		{
			*pDest++=__SEP0__;
			*pDest++=__SEP__;
			c= wcslen(__MARKER__) ;
			wcsncpy(pDest,__MARKER__ ,c);
			pDest+=c;
			*pDest++=__SEP0__;
			*pDest++=__SEP__;
			wcscpy(pDest,p+c);

		}else wcscpy(pDest,p);
	}else
	wcscpy(m_pMsg,pMsg);
	return m_pMsg;
}


class cMsgView: public VButtonWnd
{
public:
	    enum { IDD = IDD_HELP };

		cMsgView(LPCTSTR pMsg,struct __JobState * pState,BOOL bFirst=0):
			VButtonWnd(IDB_BK_APPS,getStateBitmap2Id(pState ),ICON_POS)
    	{
			//Load Icon and BackGround

			m_pMsg = 0;
			if(pMsg)
			{
				m_pMsg = FormatMsg( pMsg);
			}
			m_pState=pState ;
			m_nTargetCount = -1;
			m_bFirst = bFirst;
		}

		~cMsgView()
		{


			//::DeleteObject(hFont);
			if(m_pMsg) delete m_pMsg;
	  	}


private:
		SYSTEMTIME m_tmDue;
		int m_nTargetCount;
		TCHAR  m_szPDF[64];
		CpssScrollBar   cScrollBar;
		BOOL m_bFirst;
	    //HFONT           hFont; 
		CTextEdit       m_Edit;
		//struct __JobState * m_pState;

        TCHAR           * m_pMsg;  //Msg Data
		virtual void OnPaintExt(HDC hDC,CRect& rcPaint);
public:
	    BEGIN_MSG_MAP(cMsgView)
        MESSAGE_HANDLER(WM_INITDIALOG     ,OnCreate)
		MESSAGE_HANDLER(WM_ERASEBKGND ,OnErasebkgnd)
        MESSAGE_HANDLER(WM_PAINT      ,OnPaint) 
		MESSAGE_HANDLER(WM_USER_CHANGE_SKIN,	OnChangeSkin)
 		CPSSCOM_HANDLER(ID_LIST_SEND   , BN_CLICKED,OnSendMsg)
		CPSSCOM_HANDLER(ID_LIST_NAVI   , BN_CLICKED,OnNavi)

		CPSSCOM_HANDLER(ID_CANCEL      , BN_CLICKED,OnCancelMsg)
        CPSSCOM_HANDLER(ID_VIEW      , BN_CLICKED,OnView) 
		MESSAGE_HANDLER(IDB_LISTSCOLL_BK ,OnScoll)
		CPSSCOM_HANDLER(IDB_BTN_PLAY ,BN_CLICKED,OnBtnPlay)
		CPSSCOM_HANDLER(IDB_BTN_BACK ,BN_CLICKED,OnBtnBack)
		MESSAGE_HANDLER(WM_LBUTTONDOWN,	OnLButtonDown);
		MESSAGE_HANDLER(WM_LBUTTONUP,	OnLButtonUp);
		MESSAGE_HANDLER(WM_INITUPDATE,	OnInitUpdate);

		REFLECT_NOTIFICATIONS()	
		END_MSG_MAP()

protected:
	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	//LRESULT OnErasebkgnd(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	//LRESULT OnPaint(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnScoll(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/);
  	LRESULT OnView(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);  
	LRESULT OnSendMsg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
	LRESULT OnNavi(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
	LRESULT OnBtnPlay(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
	LRESULT OnBtnBack(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
	LRESULT OnChangeSkin(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnCancelMsg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/);
	LRESULT OnInitUpdate(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/){return 0;};
	LRESULT Update(struct __JobState* pState);

};

