#include "StdAfx.h"
#include "publicctrl.h"
#include "DrawLib.h"
#include "VJPG5CFG2.h"
#include "StatusView.h"
#include "cpss_dialog.h"
#include "palettenWnd.h"
#include "resource.h"
#define  m_btn m_Btns[0]
#define  m_btnSure m_Btns[1]
#define  m_btnHelp m_Btns[2]

extern DWORD g_dwStatuFenster;
extern BOOL enCustomBtn[9];
static BUTTON_ITEMEX Button_Help =  //Sane & Answer
	{ 548, 40,	146, 41,ID_VU_HELP   ,IDBI_BUTTON_121x43 ,IDBI_BUTTON_121x43_DN,0,0,0,0,TitleFontWide,TitleFontHeight,FW_NORMAL,ID_VU_HELP}; 

static BUTTON_ITEM Button_EngInfo[] = 
{
	{ Btn_CancelX, Btn_CancelY,	Btn_CancelWidth, Btn_CancelHeight,ID_CANCEL      ,IDBI_CANCEL       ,IDBI_CANCEL_DN },
	{ 0,0,0,0,0, 0, 0 }
};
static BUTTON_ITEMEX Button_EngInfo2[] = 
{
	{ Btn_CancelX-75, Btn_CancelY,	Btn_CancelWidth, Btn_CancelHeight,IDOK      ,IDBI_SURE       ,IDBI_SURE_DN       ,0,0,44 ,44, 0, 0, 0 }
};
static TCHAR wcsCustomText_Old[10][12]={L"",L"",L"",L"",L"",L"",L"",L"",L"",L""};
extern TCHAR wcsCustomText[10][12];
static	int  V5Buttons_PNG[] = {IDBI_BTN_BLUE,IDBI_BTN_DISABLE, IDBI_BTN_RED,IDBI_BTN_DISABLE,IDBI_BTN_PURPLE,IDBI_BTN_DISABLE,IDBI_BTN_YELLOW};

static BUTTON_ITEMEX V5Buttons_cfg[] ={ 
{300,40,218,77,ID_PAUSE,IDBI_BTN_BLUE,IDBI_BTN_BLUE_DN,0,0,0,0,0},
{ 38,120,218,77,ID_START,IDBI_BTN_DISABLE,IDBI_BTN_DISABLE_DN,0,0,0,0,0},	  
{548,120,218,77,ID_ABBRUCH,IDBI_BTN_RED,IDBI_BTN_RED_DN,0,0,0,0,0},
{300,180+14,218,77,ID_MELDUNG,IDBI_BTN_DISABLE,IDBI_BTN_DISABLE_DN,0,0,0,0,0,},
{38, 268,218,77,ID_ANGEK,IDBI_BTN_PURPLE,IDBI_BTN_PURPLE_DN,0,0,0,0,0},
{548,268,218,77,ID_ERLEDIGT,IDBI_BTN_DISABLE,IDBI_BTN_DISABLE_DN,0,0,0,0,0},
{300,348,218,77,ID_ARBEIT,IDBI_BTN_YELLOW,IDBI_BTN_YELLOW_DN,0,0,0,0,0},

{300,120,218,77,ID_TURQUOISE, IDBI_BTN_TURQUOISE, IDBI_BTN_TURQUOISE_DN,0,0,0,0,0},
{300,268,218,77,ID_VIOLET,	  IDBI_BTN_VIOLET,	  IDBI_BTN_VIOLET_DN,0,0,0,0,0,},


{0,0,0,0,0},
};


void initCustomText()
{
	int i=0;
	CString str;
	for(i=0;i<9;i++)
	{
		str.LoadString(V5Buttons_cfg[i].uId);
		wcscpy(wcsCustomText[i], (LPTSTR)(LPCTSTR)str);
	}
}
LRESULT VJPG5CFG2::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	//m_Button = V5Buttons_cfg;
	BUTTON_ITEMEX* pItem;
	
	pItem = V5Buttons_cfg;
	LRESULT l = VButtonWnd::OnInitDialog(uMsg,  wParam,  lParam, bHandled);
		int i=0;

	CREATE_BTN_TRANS2(m_btn, m_nIDBACK,Button_EngInfo[i]);
	//if(m_nIDBACK==IDB_JPG_5_CFG)
	{
		CREATE_BTN_TRANS2(m_btnSure, m_nIDBACK,Button_EngInfo2[i]);
	
		for(i=0;i<9;i++)
		{
			wcscpy(wcsCustomText_Old[i],wcsCustomText[i]);
		}
	}
	CREATE_BTN_TRANS_TID(m_btnHelp, m_nIDBACK,ID_VU_HELP,Button_Help); 
    i=0;	
	CString str;
	while(pItem[i].uId)
	{
		if(wcslen(wcsCustomText[i])>0)
			str = wcsCustomText[i];
		else
			str.LoadString(pItem[i].uId);
		m_Btns[i+3].CreateWndTrans(m_hWnd,m_nIDBACK,pItem[i].rt,
					  pItem[i].uId,
					  pItem[i].bmpId,pItem[i].bmpId_dn,0,str
					  );
		if(pItem[i].bmpId==IDBI_BTN_DISABLE)
		{
			m_Btns[i+3].EnableWindow(0);
		}
		i++;
	}
	return l;  
 
}

void VJPG5CFG2::OnPaintExt(HDC hDC,CRect&rcPaint)
{

}
	LRESULT VJPG5CFG2::OnMelDung(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
	{
		return 1;
	}
LRESULT VJPG5CFG2::OnState(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	CString str;
	int bset = 0;
	int newstat = -1;
	if( wID!=ID_START && wID!=ID_ERLEDIGT )
	{
		CpssMsgSend    dlg2(NULL,IDB_BK,1 );
		int nI=0;
		switch(wID)
		{
			case ID_ANGEK:newstat = 1011;nI=4 ;break;
			case ID_ARBEIT:newstat = 1012;nI=6 ;break;
			case ID_ABBRUCH:newstat = 1010;nI=2 ;break;
			case ID_PAUSE: nI=0;break;
			
			case ID_TURQUOISE:	newstat = 110;nI=7 ;bset=1;break;
			case ID_VIOLET:		newstat = 111;nI=8 ;bset=1;break;
			
		}
		dlg2.m_nTxtLimit = 8;
		wcscpy(dlg2.m_szMsg, wcsCustomText[nI]);
		int nRet = dlg2.DoModal();
		if(nRet==IDOK)
		{
			if(wcslen(dlg2.m_szMsg)>10) dlg2.m_szMsg[10]=0;
			//str = dlg2.m_szMsg;

			wcscpy(wcsCustomText[nI],dlg2.m_szMsg);
			bset = 1;

			
			m_Btns[nI+3].ChangeBtnCaption(wcsCustomText[nI]);
			


			return 0;
		}

	}	
	return 1;
}
LRESULT VJPG5CFG2::OnCancelMsg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	ShowWindow(SW_HIDE);
	int i;
for(i=0;i<9;i++)
		{
			wcscpy(wcsCustomText[i],wcsCustomText_Old[i]);
		}
 	EndDialog(FALSE);
	return 0;
}

LRESULT VJPG5CFG2::OnOK(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
ShowWindow(SW_HIDE);
   	EndDialog(IDOK);
	return 0;
}
	LRESULT VJPG5CFG2::OnChangeSkin(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	m_DrawList->ChangeSkin();
	EnumChildWindows(m_hWnd,EnumCallback ,0);
	return 0;
}
/*
void DrawCFGHelp(HDC hDC,TCHAR *msg,TCHAR * pExtra=0)
{
	DrawDC Draw(hDC);

	Draw.SetHelpFont() ;

	if(msg)
	{
		//int n = wcslen(msg);
		int style = DT_LEFT|DT_WORD_ELLIPSIS|DT_EXPANDTABS |DT_WORDBREAK ;
		Draw.DrawGPSOverIPStringRect(msg, CRect(110,110,690,380),style );
	}
}*/
LRESULT VJPG5CFG2::OnHelp(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	HelpBox(IDS_CFG2_HELP ,IDB_ADMIN);
/*	CString wcsMsg;
	wcsMsg.LoadString(IDS_CFG2_HELP);
	CpssMsgDlg dlg(IDB_BK,wcsMsg,IDB_ADMIN);
	dlg.m_BmpButtonTmpl =&Button_EngInfo[0];
	dlg.m_TxtButtonTmpl = 0; //0;
	dlg.fnDrawMessage = DrawCFGHelp;

	dlg.DoModal();	*/
	return 1;
}